
;----- Users Register Files ----------------------------------------------

W_TMP			EQU	H'0070'
ST_TMP			EQU	H'0071'

STATUS_KEY		EQU	H'0072'
CT_LOW			EQU	H'0073'
CT_LOW2			EQU	H'0074'
TIME			EQU	H'0075'
PRESS_TIME		EQU	H'0076'

;----STATUS_KEY---------------------------------------------

FUNC			EQU	H'0000'
RANGE			EQU	H'0001'
HOLD			EQU	H'0002'
REL				EQU	H'0003'
HZ				EQU	H'0004'
HZ_LONG			EQU	H'0005'

;----PORTA--------------------------------------------------------------------

KEY_FUNC_HOLD	EQU	H'0000'
SD7501_19		EQU	H'0002'
KEY_HZ			EQU	H'0005'

;----PORTC------------------------------------------------------------------

SD7501_22			EQU	H'0000'
SD7501_21			EQU	H'0001'
SD7501_20			EQU	H'0002'

;--------------------------------------------------------------


		include P16F684.INC
__config _INTRC_OSC_NOCLKOUT & _WDT_OFF & _BOD_OFF & _PWRTE_ON & _MCLRE_OFF


        LIST
ORG	0x0000
	goto	init
ORG	0x0004
	retfie


;-----------------------------------------------
init
;	banksel	PORTA
	movlw	b'00101001'
	movwf	PORTA
	movlw	b'00000001'
	movwf	PORTC
	movlw	b'00000111'
	movwf	CMCON0

	banksel	OPTION_REG

	movlw	b'00101101'
	movwf	WPUA
	movlw	b'00101001'
	movwf	TRISA
	movlw	b'00000111'
	movwf	TRISC
	movlw	b'00000111'
	movwf	OPTION_REG
;	movlw	b'01100000'
;	movwf	OSCCON
;	movlw	b'01000000'
;	movwf	ADCON1
	movlw	b'00000000'
	movwf	ANSEL
	banksel	PORTA
;	movlw	b'00110001'
;	movwf	T1CON


;----- START --------------------------------------
; APO
startup
	btfss	PORTA,	KEY_FUNC_HOLD
	goto	startup

	banksel	TRISA
	movlw	b'00100101'
	movwf	IOCA
	bsf	TRISA,	SD7501_19
	banksel	PORTA

	movlw	b'00001000'
	movwf	INTCON
	clrf	PRESS_TIME
	clrf	CT_LOW
	clrf	CT_LOW2
	clrf	STATUS_KEY
	clrwdt
	
main
	btfss	PORTA,	KEY_FUNC_HOLD
	goto	func_hold_control	
	btfss	PORTA,	KEY_HZ
	goto	hz_control

	goto	main


;-----------------------------------------------
;  FUNC  HOLD (DM616)
func_hold_control
	btfsc	PORTC,	SD7501_22
	goto	func_0


;  HOLD (DM616)
	btfsc	PORTA,	KEY_FUNC_HOLD
	goto	hld_1	


;   HOLD (DM616)
	incf	CT_LOW
	btfss	CT_LOW,	6
	goto	func_hold_time
	decf	CT_LOW
	bsf	STATUS_KEY,	HOLD
	goto	func_hold_time


;   HOLD (DM616)
hld_1
	decf	CT_LOW
	btfss	CT_LOW,	7
	goto	func_hold_time
	btfss	STATUS_KEY,	HOLD
	goto	hld_end
	btfsc	STATUS_KEY,	REL
	goto	hld_end


;   HOLD (SD7501)
press_hold
	movlw	.5
	movwf	TIME
	movlw	PORTC
	movwf	FSR
	banksel	TRISA
press_hld2
	btfss	INDF,	SD7501_22
	bcf	TRISA,	SD7501_19
	btfss	INDF,	SD7501_22
	goto	press_hld2
	bsf	TRISA,	SD7501_19
	btfss	INTCON,	T0IF
	goto	press_hld2
	bcf	INTCON,	T0IF	
	decfsz	TIME
	goto	press_hld2
	banksel	PORTA
hld_end
	clrf	STATUS_KEY
	call	delay
	clrf	PRESS_TIME
	clrf	CT_LOW
	clrf	CT_LOW2
	goto	main	


;  FUNC (DM616)
func_0
	btfsc	PORTA,	KEY_FUNC_HOLD
	goto	func_1	


;   FUNC (DM616)
	decf	CT_LOW
	btfsc	CT_LOW,	7
	clrf	CT_LOW

	incf	CT_LOW2
	btfss	CT_LOW2,	6
	goto	func_hold_time
	decf	CT_LOW2
	bsf	STATUS_KEY,	FUNC
	goto	func_hold_time


;   FUNC (DM616)
func_1
	decf	CT_LOW2
	btfss	CT_LOW2,	7
	goto	func_hold_time
	clrf	CT_LOW2
	btfss	STATUS_KEY,	FUNC
	goto	func_hold_time
	btfsc	STATUS_KEY,	RANGE
	goto	func_hold_time


;   SELECT (SD7501)
press_sel
	banksel	TRISA
	bcf	TRISA,	SD7501_19
	banksel	PORTA
	call	delay
	banksel	TRISA
	bsf	TRISA,	SD7501_19
	banksel	PORTA

	clrf	STATUS_KEY
	clrf	PRESS_TIME
	clrf	CT_LOW
	clrf	CT_LOW2
	call	delay
	goto	main	


;   (DM616)
func_hold_time
	btfss	INTCON,	T0IF
	goto	func_hold_control
	bcf	INTCON,	T0IF

	movlw	.0
	btfsc	STATUS_KEY,	FUNC
	movlw	.1
	btfsc	STATUS_KEY,	HOLD
	movlw	.1
	addwf	PRESS_TIME
	btfss	PRESS_TIME,	4
	goto	func_hold_control
	clrf	PRESS_TIME

	btfsc	STATUS_KEY,	FUNC
	goto	press_range
	btfsc	STATUS_KEY,	HOLD
	goto	press_rel
	goto	func_hold_control


;   RANGE (SD7501)
press_range
	banksel	TRISC
	bcf	TRISC,	SD7501_20
	banksel	PORTC
	call	delay
	banksel	TRISC
	bsf	TRISC,	SD7501_20
	banksel	PORTC
	call	delay
	bsf	STATUS_KEY,	RANGE
	goto	func_hold_control


;   REL (SD7501)
press_rel
	banksel	TRISC
	bcf	TRISC,	SD7501_21
	banksel	PORTC
	call	delay
	banksel	TRISC
	bsf	TRISC,	SD7501_21
	banksel	PORTC
	call	delay
	bsf	STATUS_KEY,	REL
	goto	func_hold_control


;---------------------------------------------
;  HZ (DM616)
hz_control
	btfsc	PORTC,	SD7501_22
	goto	hz_1

	btfsc	PORTA,	KEY_HZ
	goto	hz_0	


;   HZ (DM616)	
	incf	CT_LOW
	btfss	CT_LOW,	6
	goto	hz_1
	decf	CT_LOW
	bsf	STATUS_KEY,	HZ
	goto	hz_1


;   HZ (DM616)
hz_0
	decf	CT_LOW
	btfss	CT_LOW,	7
	goto	hz_1
;	clrf	CT_LOW
	btfss	STATUS_KEY,	HZ_LONG
	btfss	STATUS_KEY,	HZ
	goto	hz_end
	goto	press_maxmin


; 
hz_1
	btfss	INTCON,	T0IF
	goto	hz_control
	bcf	INTCON,	T0IF

	btfsc	STATUS_KEY,	HZ
	incf	PRESS_TIME
	btfss	PRESS_TIME,	4
	goto	hz_control


;   HZ (SD7501)
	bsf	STATUS_KEY,	HZ_LONG
press_hz
	movlw	.5
	movwf	TIME
	clrf	TMR0
	bcf	INTCON,	T0IF
	movlw	PORTC
	movwf	FSR
	banksel	TRISC
press_hz2
	btfss	INDF,	SD7501_22
	bcf	TRISC,	SD7501_21
	btfss	INDF,	SD7501_22
	goto	press_hz2
	bsf	TRISC,	SD7501_21
	btfss	INTCON,	T0IF
	goto	press_hz2
	bcf	INTCON,	T0IF
	decfsz	TIME
	goto	press_hz2
	banksel	PORTC
	goto	hz_end1


;   MIN/MAX (SD7501)
press_maxmin
	movlw	.5
	movwf	TIME
	clrf	TMR0
	bcf	INTCON,	T0IF
	movlw	PORTC
	movwf	FSR
	banksel	TRISC
press_mm2
	btfss	INDF,	SD7501_22
	bcf	TRISC,	SD7501_20
	btfss	INDF,	SD7501_22
	goto	press_mm2	
	bsf	TRISC,	SD7501_20	
	btfss	INTCON,	T0IF
	goto	press_mm2
	bcf	INTCON,	T0IF
	decfsz	TIME
	goto	press_mm2
	banksel	PORTC
hz_end
	clrf	STATUS_KEY
hz_end1
	call	delay
	clrf	PRESS_TIME
;	clrf	STATUS_KEY
	clrf	CT_LOW
	goto	main	


;-------------------

delay
	movlw	.5
	movwf	TIME
del1
	btfss	INTCON,	T0IF
	goto	$-1
	bcf	INTCON,	T0IF
	decfsz	TIME
	goto	del1	
	return

END

